"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createIpcRequestHandler = createIpcRequestHandler;

var _prevalResource = require("./preval-resource");

function createIpcRequestHandler() {
  const inflightResources = new Map();
  const resolvedResources = new Map();
  return async function ipcRequestHandler(resource) {
    if (resolvedResources.has(resource)) {
      return resolvedResources.get(resource);
    }

    const inflight = inflightResources.get(resource);

    if (inflight) {
      return new Promise(resolve => {
        inflight.add(resolve);
      });
    }

    const inflightRequests = new Set();
    inflightResources.set(resource, inflightRequests);
    const result = await (0, _prevalResource.prevalResource)(resource);
    resolvedResources.set(resource, result);

    for (const resolver of inflightRequests) {
      resolver(result);
    }

    inflightResources.delete(resource);
    return result;
  };
}
//# sourceMappingURL=create-ipc-request-handler.js.map